import sys

# Problem 1
def p1_answers(strs, nums_a, nums_b, tups):
    # a. Given a list of strings called strs, call map() or
    # use a list comprehension to produce a result where
    # all the strings are duplicated.
    # E.g., strs = ['abc', 'def'], then
    # answer_a becomes ['abcabc', 'defdef']

    answer_a = None # student code here

    # b. Given a list of numbers called nums_a, use a list
    # comprehension to return a list of only the numbers
    # greater than 4.
    # e.g., [8, 5, 3, 9, 2, 1, 4, 1]
    # answer_b becomes [8, 5, 9]

    answer_b = None # student code here

    # c. Given a list of numbers called nums_b,
    # use a map() or a list comprehension to produce a result where
    # each number becomes a tuple of the number divided by 2
    # (using integer division) and the remainder of the number
    # divided by 2.
    # e.g., [12, 3, 9, 0, 8]
    # answer_c becomes [(6, 0), (1, 1), (4, 1), (0, 0), (4, 0)]

    answer_c = None # student code here

    # d. Given a list of tuples of any length called tups,
    # produce a sorted list that is sorted by the last
    # element in each tuple.
    # e.g., tups = [(1, 2, 3), (4, 5), (5, 4), (2, 2, 2, 2)]
    # answer_d becomes: [(2, 2, 2, 2), (1, 2, 3), (5, 4), (4, 5)]

    answer_d = None # student code here

    return (answer_a, answer_b, answer_c, answer_d)


# Problem 2

def extract_pop_and_size(filename):
    states = {}
    with open(filename) as f:
        for line in f:
            line = line[:-1]  # remove newline

    # student code here:
    pass

    return states


# Problem 3
def population_density(states):
    # Student code here:
    pass


###############################################
def main():
    if len(sys.argv) < 2:
        print(f'Usage: {sys.argv[0]} p1|p2|p3 --show-correct-soln-only')
        print('E.g., to test problem 1:')
        print(f'E.g., {sys.argv[0]} p1')
        quit()
    problem = sys.argv[1]
    show_solution = False
    if len(sys.argv) == 3 and sys.argv[2] == '--show-correct-soln-only':
        show_solution = True

    if problem == 'p1':
        # testing one-liners
        fn = p1_answers
        if show_solution:
            fn = p1_answers_soln
            print("SHOWING CORRECT SOLUTION")

        strs = ['abc', 'xyz', 'www', '123', '#', '']
        nums_a = [1, 5, 2, 3, 8, 7, 7, 10000]
        nums_b = [0, 12, 15, 8, 3, 9, 7, 12345]
        tups = [(1, 2, 3), (4, 5), (5, 4), (2, 2, 2, 2), (8,)]
        a, b, c, d = fn(strs, nums_a, nums_b, tups)
        print(f'strs: {strs}')
        print(f'answer_a: {a}')
        print()
        print(f'nums_a: {nums_a}')
        print(f'answer_b: {b}')
        print()
        print(f'nums_b: {nums_b}')
        print(f'answer_c: {c}')
        print()
        print(f'tups: {tups}')
        print(f'answer_d: {d}')

    elif problem == 'p2':
        # testing extract_pop_and_size
        fn = extract_pop_and_size
        if show_solution:
            fn = extract_pop_and_size_soln
            print("SHOWING CORRECT SOLUTION")

        result = fn('states_data.txt')
        for k, v in result.items():
            print(f'{k}: {v}')
    elif problem == 'p3':
        # testing population_density
        fn = population_density
        if show_solution:
            fn = population_density_soln
            print("SHOWING CORRECT SOLUTION")
        result = fn(extract_pop_and_size_soln('states_data.txt'))
        for v in result:
            print(v)


# Solutions:
def p1_answers_soln(strs, nums_a, nums_b, tups):
    # a. Given a list of strings called strs, call map() or
    # use a list comprehension to produce a result where
    # all the strings are duplicated.
    # E.g., strs = ['abc', 'def'], then
    # answer_a becomes ['abcabc', 'defdef']

    answer_a = [x + x for x in strs]

    # b. Given a list of numbers called nums_a, use a list
    # comprehension to return a list of only the numbers
    # greater than 4.
    # e.g., [8, 5, 3, 9, 2, 1, 4, 1]
    # answer_b becomes [8, 5, 9]

    answer_b = [n for n in nums_a if n > 4]

    # c. Given a list of numbers called nums_b,
    # use a map() or a list comprehension to produce a result where
    # each number becomes a tuple of the number divided by 2
    # (using integer division) and the remainder of the number
    # divided by 2.
    # e.g., [12, 3, 9, 0, 8]
    # answer_c becomes [(6, 0), (1, 1), (4, 1), (0, 0), (4, 0)]

    answer_c = [(n // 2, n % 2) for n in nums_b]

    # d. Given a list of tuples of any length called tups,
    # produce a sorted list that is sorted by the last
    # element in each tuple.
    # e.g., tups = [(1, 2, 3), (4, 5), (5, 4), (2, 2, 2, 2)]
    # answer_d becomes: [(2, 2, 2, 2), (1, 2, 3), (5, 4), (4, 5)]

    answer_d = sorted(tups, key=lambda x: x[-1])

    return (answer_a, answer_b, answer_c, answer_d)



def extract_pop_and_size_soln(filename):
    states = {}
    with open(filename) as f:
        for line in f:
            line = line[:-1]  # remove newline
            # Arizona 6828065 294207.1
            end = 0
            while end < len(line) and not line[end].isdigit():
                end += 1
            state = line[:end - 1]  # don't include space
            rest = line[end:]
            pop, size = rest.split(' ')
            states[state] = {'population': int(pop),
                             'land_area': float(size)
                             }
    return states


def population_density_soln(states):
    state_list = []
    for state in states:
        pop = states[state]['population']
        size = states[state]['land_area']
        density = pop / size
        state_list.append((state, density))

    return sorted(state_list, key=lambda x: x[1], reverse=True)


if __name__ == "__main__":
    main()
